<template>
    <div class="image-viewer" :style="previewStyle" v-if="!brokenURL">
        <img class="image-viewer__preview" :src="src" :alt="alt" :title="src"
            @click="openPopup" @error="imageLoadError" @load="imageLoadCompleted"/>
        <el-dialog v-if="dialogVisible" :visible="dialogVisible" @close="closePopup" :show-close="false">
            <img class="image-viewer__full" :src="src" :alt="alt" @click="closePopup" />
        </el-dialog>
    </div>
    <span v-else><p class="load-error"><i class="el-icon-warning"></i> Image url is invalid or broken:</p>{{src}}</span>
</template>

<script>

export default {
    props: {
        /** image url */
        src: {
            type: String,
            required: true,
        },
        /** image alt text */
        alt: {
            type: String,
            required: false,
            default: 'Image view',
        },
        /** width of preview image */
        previewWidth: {
            type: String,
            required: false,
            default: '10rem',
        },
        /** height of preview image */
        previewHeight: {
            type: String,
            required: false,
            default: '10rem',
        },
    },
    data() {
        return {
            dialogVisible: false,
            brokenURL: false,
        };
    },
    computed: {
        previewStyle: vm => ({ width: vm.previewWidth, height: vm.previewHeight }),
    },
    methods: {
        /** Event handler for opening popup */
        openPopup() {
            this.dialogVisible = true;
        },
        /** Event handler for closing popup */
        closePopup() {
            this.dialogVisible = false;
        },
        /** image url is invalid or broken */
        imageLoadError() {
            this.brokenURL = true;
        },
        /** image url is valid */
        imageLoadCompleted() {
            this.brokenURL = false;
        },
    },
};
</script>

<style lang="stylus" scoped>
.image-viewer__preview
    max-width: 100%
    max-height: 100%
    cursor pointer

.load-error
    color: $base_red

>>> .el-dialog__wrapper
    display: flex
    justify-content: center
    align-items: center
    cursor pointer

>>> .el-dialog
    margin-top: 0 !important
    width: auto !important

>>> .el-dialog__header
    padding: 0

>>> .el-dialog__body
    display: flex
    padding: 0

</style>
